local skills = {}

function get_base_skills_from_page()
	-- attack

	local tackpic = string.match(text, "<input type=hidden name=action value=\"attack\">.-<input id='tack' picurl=([a-z0-9_]+) ")
	if tackpic then
		skills["Attack"] = {
			["name"] = "Attack",
			["basename"] = "Attack",
			["picture"] = tackpic,
			["type"] = "attack",
		}
	end

	-- run away

	if string.match(text, "<input type=hidden name=action value=\"steal\">") then
		skills["Pick Pocket"] = {
			["name"] = "Pick Pocket",
			["basename"] = "Pick Pocket",
			["picture"] = "knobsack",
			["type"] = "steal",
		}
	end

	-- jiggle chefstaff

	local jiggpic = string.match(text, "<input type=hidden name=action value=\"chefstaff\">.-<input id='chefstaffbutton' picurl=([a-z0-9_]+) ")
	if jiggpic then
		skills["Jiggle Chefstaff"] = {
			["name"] = "Jiggle Chefstaff",
			["basename"] = "Jiggle Chefstaff",
			["picture"] = jiggpic,
			["type"] = "chefstaff",
		}
	end

	-- pastamancer ghost
	--~ TODO

	-- skills

	local skilltext = string.match(text, "<select name=whichskill>(.-)</select>") or ""
	for id, pic, name, cost in string.gmatch(skilltext, "<option value=\"([0-9]-)\" picurl=\"([a-z0-9]-)\" .->(.-) %(([0-9]-) M[a-z]- Points?%)</option>") do -- TODO: double .-, redo regex?
		skills[name] = {
			["name"] = name,
			["basename"] = name,
			["picture"] = pic,
			["type"] = "spell",
			["cost"] = cost,
			["spellid"] = id,
		}
	end

	-- items

	local itemtext = string.match(text, "<select name=whichitem>(.-)</select>") or ""
	itemtext = string.gsub(itemtext, "(<option picurl=[a-z0-9]-) selected (value=[0-9]->)", "%1 %2")
	for pic, id, name, amount in string.gmatch(itemtext, "<option picurl=([a-z0-9]-) value=([0-9]-)>(.-) %(([0-9]-)%)</option>") do
		skills[name] = {
			["name"] = name,
			["basename"] = name,
			["picture"] = pic,
			["type"] = "item",
			["amount"] = amount,
			["itemid"] = id,
		}
	end

	-- funkslinging
	if string.match(text, "<select name=whichitem2>") then
		skills["Ambidextrous Funkslinging"] = {
			["name"] = "Ambidextrous Funkslinging",
			["basename"] = "Ambidextrous Funkslinging",
			["picture"] = "",
			["type"] = "funksling",
			["virtual"] = true,
		}
	end

	-- stop automation
	--~ skills["stop"] = {
	--~ 	["name"] = "stop",
	--~ 	["basename"] = "stop",
	--~ 	["picture"] = "",
	--~ 	["type"] = "stop",
	--~ 	["virtual"] = true,
	--~ }
end

function set_custom_combat_skill(name, basename, extra, auto)
--~ 	print("setting " .. tostring(name) .. " to " .. tostring(basename) .. ", extra: " .. tostring(extra))
	if skills[basename] then
		local picture = skills[basename]["picture"]
		local itemid = skills[basename]["itemid"]
		local itemid2 = skills[basename]["itemid2"]
		displayname = skills[basename]["basename"]
		local extratext = tostring(extra)
		if extra then
			extratext = table_to_str(extra)
		end
		if basename == "Ambidextrous Funkslinging" then
			if type(extra) ~= "table" then return end
			one = extra["first"]
			two = extra["second"]
			if not skills[one] or not skills[two] then return end
			picture = skills[one]["picture"]
			itemid = skills[one]["itemid"]
			itemid2 = skills[two]["itemid"]
			displayname = displayname .. " (" .. one .. " + " .. two .. ")"
		end
		extra_text = nil
		if extra then extra_text = table_to_str(extra) end
		table.insert(custom_combat_skills, name)
		skills[name] = {
			["name"] = name,
			["basename"] = displayname,
			["picture"] = picture,
			["type"] = skills[basename]["type"],
			["spellid"] = skills[basename]["spellid"],
			["itemid"] = itemid,
			["itemid2"] = itemid2,
			["cost"] = skills[basename]["cost"],
			["amount"] = skills[basename]["amount"],
			["auto"] = auto,
			["extra"] = extra_text,
		}
	else
		print("Custom combat skill error! Baseskill doesn't exist!", name, "->", basename)
	end
end

local resolve_list = {}
local entered = {}
local function process_skill(name, extrain)
	for x, description in pairs(resolve_list[name]) do
		local passed_filters = true

		local filters = {}

		filters["round"] = (function (test)
			test = string.gsub(test, " ", "")
			local roundmin, roundmax = string.match(test, "^([0-9]+)%-(([0-9]+))$")
			if not roundmin then
				roundmin = string.match(test, "^([0-9]+)%+$")
				roundmax = "1000"
			end
			if not roundmin then
				roundmin = string.match(test, "^([0-9]+)$")
				roundmax = roundmin
			end
			if combat_round then
--~ 				print("testing round", combat_round, roundmin, roundmax)
				if combat_round < tonumber(roundmin) or combat_round > tonumber(roundmax) then
					return false
				end
			else
				return false
			end
		end)

		filters["zone"] = (function (test)
			local z = tonumber(string.match(test, "^([0-9]+)$"))
-- 			print("testing zone", zone, z)
			if adventure_zone ~= z then
				return false
			end
		end)

		filters["monster"] = (function (test)
			if monster_name == test then
				return true
			else
				return false
			end
		end)

		extra = extrain

		filters["once"] = (function (test)
			onceflag = "once." .. test
			v = get_fight_state(onceflag)
			if v == "" then
				if not extra then extra = {} end
				extra["once flag"] = onceflag
				return true
			else
				return false
			end
		end)

		filters["first"] = (function (test)
			if not extra then extra = {} end
			extra["first"] = test
			return true
		end)
		filters["second"] = (function (test)
			if not extra then extra = {} end
			extra["second"] = test
			return true
		end)

		filters["r"] = filters["round"]
		filters["z"] = filters["zone"]
		filters["m"] = filters["monster"]

		for code, rawtest in string.gmatch(description, "([a-z]+) *(%b{})") do
--~ 			print(name, code, rawtest)
			if filters[code] then
				local test = string.match(rawtest, "^{ *(.-) *}$") -- TODO: redo regex, .- and  +
--~ 				print("filtertest", code, test, "=>", filters[code](test))
				if filters[code](test) == false then
					passed_filters = false
				end
			else
				passed_filters = false
			end
		end

		if passed_filters then
			local skillname = string.gsub(description, " *[a-z]+ *%b{} *", "")
--~ 			print("skill", name, description, "["..skillname.."]")
			if resolve_list[skillname] and not entered[skillname] then
				entered[skillname] = true
				local s, extra = process_skill(skillname, extra)
				if s then return s, extra end
			end
			if skills[skillname] then
--~ 				print(" => ", skillname, printstr(extra))
				return skillname, extra
			end
		end
	end
end

function setup_skills_tables()
	get_base_skills_from_page()

	-- scripted custom skills

	local toset = {}
	for a, b in pairs(combat_skill_functions) do
		x, extra = b.f(skills)
		if x then
			table.insert(toset, { name = b.name, skill = x, extra = extra, auto = b.auto })
		end
	end
	for a,b in pairs(toset) do set_custom_combat_skill(b.name, b.skill, b.extra, b.auto) end

	-- simple user-specified custom skills

	for a, b in pairs(simple_combat_skills) do
		resolve_list[b.name] = b.list
	end

	local toset = {}
	for a, b in pairs(simple_combat_skills) do
		entered = {}
		s, extra = process_skill(b.name, nil)
		if s then
			table.insert(toset, { name = b.name, skill = s, extra = extra, auto = b.auto })
		end
	end
	for a,b in pairs(toset) do set_custom_combat_skill(b.name, b.skill, b.extra, b.auto) end
end


-- do it

-- posting page /fight.php params: Just [("action","useitem"),("whichitem","2176"),("whichitem2","2174")]

add_processor("/fight.php", function ()
	setup_skills_tables()
	local combat_skill_state_table = {}
	for a,b in pairs(custom_combat_skills) do
		data = skills[b]
--~ 		print("skill", data["name"], table_to_str(data))
		if data["type"] == "spell" then
			combat_skill_state_table[data["name"]] = { basename = data["basename"], postdata = table_to_str({ action = "skill", whichskill = data["spellid"] }), auto = data["auto"], data = table_to_str(data) }
		elseif data["type"] == "item" then
			combat_skill_state_table[data["name"]] = { basename = data["basename"], postdata = table_to_str({ action = "useitem", whichitem = data["itemid"] }), auto = data["auto"], data = table_to_str(data) }
		elseif data["type"] == "attack" then
			combat_skill_state_table[data["name"]] = { basename = data["basename"], postdata = table_to_str({ action = "attack" }), auto = data["auto"], data = table_to_str(data) }
		elseif data["type"] == "steal" then
			combat_skill_state_table[data["name"]] = { basename = data["basename"], postdata = table_to_str({ action = "steal" }), auto = data["auto"], data = table_to_str(data) }
		elseif data["type"] == "chefstaff" then
			combat_skill_state_table[data["name"]] = { basename = data["basename"], postdata = table_to_str({ action = "chefstaff" }), auto = data["auto"], data = table_to_str(data) }
		elseif data["type"] == "funksling" then
			combat_skill_state_table[data["name"]] = { basename = data["basename"], postdata = table_to_str({ action = "useitem", whichitem = data["itemid"], whichitem2 = data["itemid2"] }), auto = data["auto"], data = table_to_str(data) }
		elseif data["type"] == "stop" then
			combat_skill_state_table[data["name"]] = { basename = data["basename"], postdata = table_to_str({}), special = "stop", auto = data["auto"], data = table_to_str(data) }
		end
	end
-- 	print("setting combat skills fightstate: " .. table_to_str(combat_skill_state_table))
	set_fight_state("combat skills", table_to_str(combat_skill_state_table))
end)

add_printer("/fight.php", function ()
	setup_skills_tables()
	for a,b in pairs(custom_combat_skills) do
		data = skills[b]
		if data["virtual"] ~= true then
			if data.auto == "yes" then
				text = string.gsub(text, "(<select name=whichskill>.-)(</select>)", "%1<option value=\""..("custom autoskill "..data["name"]).."\" picurl=\""..data["picture"].."\" >"..data["name"].." ("..(data["cost"] or 0).." Mana Points)</option>%2")
			else
				text = string.gsub(text, "(<select name=whichskill>.-)(</select>)", "%1<option value=\""..("custom skill "..data["name"]).."\" picurl=\""..data["picture"].."\" >"..data["name"].." ("..(data["cost"] or 0).." Mana Points)</option>%2")
			end
		end
	end
end)




add_processor("/fight.php", function()
	pattern = "<center><table class=\"item\" style=\"float: none\" rel=\"[^\"]*\"><tr><td><img src=\"http://images.kingdomofloathing.com/itemimages/[^\"]+.gif\" alt=\"([^\"]*)\" title=\"([^\"]*)\" class=hand onClick='descitem%([0-9]+%)'></td><td valign=center class=effect>You acquire an item: <b>([^<]+)</b></td></tr></table></center>"
	for alt, title, item in string.gmatch(text, pattern) do
--~ 		print("item drop", alt, title, 1, item)
	end
	pattern = "<center><table class=\"item\" style=\"float: none\" rel=\"[^\"]*\"><tr><td><img src=\"http://images.kingdomofloathing.com/itemimages/[^\"]+.gif\" alt=\"([^\"]*)\" title=\"([^\"]*)\" class=hand onClick='descitem%([0-9]+%)'></td><td valign=center class=effect>You acquire <b>([0-9]+) ([^<]+)</b></td></tr></table></center>"
	for alt, title, amount, item in string.gmatch(text, pattern) do
--~ 		print("item drop", alt, title, amount, item)
	end
	pattern = "<center><table class=\"item\" style=\"float: none\" rel=\"[^\"]*\"><tr><td><img src=\"http://images.kingdomofloathing.com/itemimages/[^\"]+.gif\" alt=\"([^\"]*)\" title=\"([^\"]*)\" class=hand onClick='descitem%([0-9]+%)'></td><td valign=center class=effect>You acquire <b>(11) ([^<]+)</b><br>%(That's ridiculous.  It's not even funny.%)</td></tr></table></center>"
	for alt, title, amount, item in string.gmatch(text, pattern) do
--~ 		print("item drop", alt, title, amount, item)
	end
end)

add_printer("/fight.php", function()
	pattern = "(<center><Table><tr><td><img src=\"http://images.kingdomofloathing.com/itemimages/mp.gif\" height=30 width=30></td><td valign=center class=effect>)(You gain )([0-9]+)( M[a-z]+ Points.)(</td></tr></table></center>)"
	text = string.gsub(text, pattern, "%1<span style=\"color: darkblue\">%2%3%4</span>%5")

	pattern = "(<center><table><tr><td><img src=\"http://images.kingdomofloathing.com/itemimages/hp.gif\" height=30 width=30></td><td valign=center class=effect>)(You gain )([0-9]+)( hit points.)(</td></tr></table></center>)"
	text = string.gsub(text, pattern, "%1<span style=\"color: darkred\">%2%3%4</span>%5")
end)


add_printer("/fight.php", function()
	pattern = "(<b>)(Combat)(!</b>)"
	text = string.gsub(text, pattern, "%1%2 round " .. tostring(combat_round) .. "%3")

	awesome_monsters = {
		[" Bob Racecar"] = "ketchup hound",
		["a gaudy pirate"] = "snakehead charrrm",
		["some zombie waltzers"] = "dance card",
		["a blur"] = "drum machine",
		["a rampaging adding machine"] = "64735 scroll",
		["a cleanly pirate"] = "rigging shampoo",
		["a creamy pirate"] = "ball polish",
		["a curmudgeonly pirate"] = "mizzenmast mop",
		["a dairy goat"] = "goat cheese",
	}

	-- yossarian's tools / gremlins, TODO: move to lvl12 zone file
	if get_fight_state("gremlin.type") ~= "no tool" then
		if adventure_zone == 182 then
			awesome_monsters["a batwinged gremlin"] = "molybdenum hammer"
		elseif adventure_zone == 184 then
			awesome_monsters["an erudite gremlin"] = "molybdenum crescent wrench"
		elseif adventure_zone == 183 then
			awesome_monsters["a spider gremlin"] = "molybdenum pliers"
		elseif adventure_zone == 185 then
			awesome_monsters["a vegetable gremlin"] = "molybdenum screwdriver"
		end
	end

	local color = "darkslategray"
	local extra = ""
	if awesome_monsters[monster_name] then
		color = "royalblue"
		extra = extra .. "<br><center style=\"font-size: 75%%; color: green\">[" .. awesome_monsters[monster_name] .. "]</center>"
	end

	-- TODO: This should be in pirates.lua, and preferably transfer zone to printer after fight state reset, and should actually be removed after that!
	loadzone = tonumber(get_ascension_state("adventure.lastzone"))
	if loadzone == 157 then
		local tbl = get_ascension_state("zone.pirates.insults")
		if (tbl == "") then tbl = {} else tbl = str_to_table(tbl) end
		extra = extra .. "<br><center style=\"font-size: 75%%; color: green\">" .. table.maxn(tbl).." / 8 insults</center>"
	end

	pattern = "(<span id='monname')(>)([^<]+)(</span>)"
	text = string.gsub(text, pattern, "%1 style=\"color: "..color.."\"%2(%3)%4" .. extra)
end)
