function encode_thing(x)
	if type(x) == "number" then return tostring(x)
	elseif type(x) == "string" then return string.format("%q", x)
	elseif type(x) == "boolean" then
		if x == true then
			return "True"
		else
			return "False"
		end
	elseif type(x) == "table" then
		return table_to_str(x)
	end
end

function decode_string(x) -- can this be done in a better way?
	f = loadstring("return " .. x)
	if f then
		return f()
	else
		return nil
	end
end

function decode_thing(x)
	local num = tonumber(x)
	if num then return num end
	if x == "True" then return true end
	if x == "False" then return false end
	local str = string.match(x, "^\"(.+)\"$") -- TODO: redo these in some other way?
	if str then
		s = decode_string(x)
		if s then return s end
	end
	local tblstr = string.match(x, "^(%[.+%])$") -- TODO: redo these in some other way?
	if tblstr then return str_to_table(tblstr) end
end

function table_to_str(tbl)
	local newtbl = {}
	for from, to in pairs(tbl) do
--~ 		print("tbl["..tostring(from).."] -> "..tostring(to))
		table.insert(newtbl, string.format("(%s, %s)", encode_thing(from), encode_thing(to)))
	end
	return "["..table.concat(newtbl, ", ").."]"
end

function str_to_table(str)
	local tbl = {}
--~ 	print("str_to_table("..str..")")
	for x in string.gmatch(str, "%b()") do
		a, b = string.match(x, "^%((.-), *(.+)%)$") -- TODO: redo regex?
--~ 		print("decoding", a, "->", b)
		tbl[decode_thing(a)] = decode_thing(b)
	end
--~ 	print("returning", table_to_str(tbl))
	return tbl
end

function printstr(tbl)
	if tbl == nil then
		return tostring(tbl)
	elseif type(tbl) == "table" then
		return table_to_str(tbl)
	else
		return tostring(tbl)
	end
end

function increase_daily_counter(name)
	local value = get_day_state(name)
	if (value == "") then value = 0 end
	value = value + 1
	set_day_state(name, value)
end

function get_daily_counter(name)
	local value = get_day_state(name)
	if (value == "") then value = 0 end
	return value
end

local familiar_counters = {}
local infolines = {}
local values = {}

function print_familiar_counter(compact, normal)
	if string.match(text, "<!%-%- charpane compact") then
		table.insert(familiar_counters, compact)
	else
		table.insert(familiar_counters, normal)
	end
end

function print_charpane_infoline(compact, normal)
	if string.match(text, "<!%-%- charpane compact") then
		table.insert(infolines, compact)
	else
		table.insert(infolines, normal)
	end
end

function print_charpane_value(value)
	table.insert(values, value)
end

function print_charpane_lines()
	if string.match(text, "<!%-%- charpane compact") then -- compact mode
		local lines = {}
		for x,y in pairs(familiar_counters) do table.insert(lines, y) end
		for x,y in pairs(infolines) do table.insert(lines, y) end

		for x,y in pairs(lines) do
			if string.match(text, "</table>(<!%-%- charpane compact familiar text space type%b{} weight%b{} %-%->)") then
				text = string.gsub(text, "(<!%-%- charpane compact familiar text space type%b{} weight%b{} %-%->)", y .. "%1")
			else
				text = string.gsub(text, "(<!%-%- charpane compact familiar text space type%b{} weight%b{} %-%->)", "<br>" .. y .. "%1")
			end
		end
		for x,y in pairs(values) do
			local name = y["name"] or "{nil}"
			local value = y["value"] or "{nil}"
			local ct = "<td align=right>" .. name .. ":</td><td align=left><b>" .. value .. "</b></td>"
			local style = ""
			if y["color"] then
				style = " style=\"color:" .. y["color"] .. "\""
			end
			if y["tooltip"] then
				ct = "<tr title=\"" .. y["tooltip"] .. "\"" .. style .. ">" .. ct .. "</tr>"
			else
				ct = "<tr" .. style .. ">" .. ct .. "</tr>"
			end
			text = string.gsub(text, "(<!%-%- charpane compact text space %-%->)", ct .. "%1")
		end
	else -- normal mode
		local lines = {}
		for x,fc in pairs(familiar_counters) do table.insert(lines, tostring(fc)) end
		for x,il in pairs(infolines) do table.insert(lines, tostring(il)) end

		for x,l in pairs(lines) do
			text = string.gsub(text, "(<!%-%- charpane normal familiar text space type%b{} weight%b{} %-%->)", "<tr><td colspan=\"2\"><center><font size=\"2\">" .. l .. "</font></center></td></tr>%1")
		end
		for x,y in pairs(values) do
			local name = y["name"] or "{nil}"
			local value = y["value"] or "{nil}"
			local nt = "<font size=\"2\">" .. name .. ": <b>" .. value .. "</b></font>"

			local style = ""
			if y["color"] then
				style = " style=\"color:" .. y["color"] .. "\""
			end
			if y["tooltip"] then
				nt = "<span title=\"" .. y["tooltip"] .. "\"" .. style .. ">" .. nt .. "</span>"
			else
				nt = "<span" .. style .. ">" .. nt .. "</span>"
			end
			text = string.gsub(text, "(<!%-%- charpane normal text space %-%->)", nt .. "<br>%1")
		end
	end
end
