add_processor("/desc_item.php", function()
	glyph = string.match(text, "title=\"(Arcane Glyph #[0-9]+)\"")
	if glyph then
		tbl = get_ascension_state("zone.manor.glyphs")
		if (tbl == "") then tbl = {} else tbl = str_to_table(tbl) end
		name = string.match(text, "<b>(dusty bottle of [A-Za-z ]+)</b>")
		print(name .. " -> " .. glyph)
		tbl[glyph] = name
		set_ascension_state("zone.manor.glyphs", table_to_str(tbl))
	end
end)

add_printer("/manor3.php", function()
	tbl = get_ascension_state("zone.manor.glyphs")
	if (tbl == "") then tbl = {} else tbl = str_to_table(tbl) end
	prints = {}
	for x in string.gmatch(text, "title=\"(Arcane Glyph #[0-9]+)\"") do
		print("glyph:"..x.." -> "..tostring(tbl[x]))
		table.insert(prints, tostring(tbl[x])) -- TODO: Format as HTML ordered list
	end
	text = string.gsub(text, "How curious.", "%0<br><br>"..table.concat(prints, "<br>"))
end)

add_processor("/fight.php", function ()
	-- track item drop
	-- zones: 178, 179
	--        180, 181
end)

--~ billiards room

add_choice_text("Minnesota Incorporeals", {
	["Break"] = "Gain moxie",
	["Let the ghost break"] = "<b>Unlock library</b> or gain muscle",
	["Run away"] = "Leave (does not cost an adventure)",
})

add_choice_text("Broken", {
	["Go for a solid"] = "<b>Unlock library</b> or gain mysticality",
	["Go for a stripe"] = "Gain muscle",
	["Go for a walk"] = "Leave (does not cost an adventure)",
})

add_choice_text("A Hustle Here, a Hustle There", {
	["Go for the 8%-ball"] = "<b>Unlock library</b> (with Chalky Hand active)",
	["Play defensively"] = "Gain mysticality",
	["Chicken out"] = "Leave (does not cost an adventure)",
})


-- library

add_choice_text("Take a Look, it's in a Book!", {
	["Read &quot;The Rise of the House of Spookyraven&quot;"] = "Read stories...",
	["Read &quot;The Better Haunted Homes and Conservatories Cookbook&quot;"] = "Get a random cooking recipe",
	["Read &quot;Ancient Forbidden Unspeakable Evil, a Love Story&quot;"] = "Gain myst or mox or myst spookyraven skill...",
	["Reading is for losers.  I'm outta here."] = "Leave (does not cost an adventure)",

	["Read &quot;The Fall of the House of Spookyraven&quot;"] = "Unlock tombstone adventure...",
	["Read &quot;To Serve Man... Delicious Cocktails&quot;"] = "Get a random mixing recipe",
	["Read &quot;Ancient Forbidden Unspeakable Yoga, a Beginner's Guide&quot;"] = "Gain muscle and take damage",
})

add_choice_text("Naughty, Naughty...", {
	["Read Chapter 1:  Tuesdays with Abhorrent Fiends"] = "Gain myst",
	["Read Chapter 2:  The Nether Planes on 350 Meat a Day"] = "Gain mox",
	["Read Chapter 3:  Twisted, Curdled, Corrupt Energy and You"] = "Gain myst spookyraven skill or take damage",
})

--~ add_choice_text("History is Fun!", { -- choice adventure number: 87
--~ 	["Read Chapter 1: Things Get Weirder"] = "",
--~ 	["Read Chapter 2: Stephen and Elizabeth"] = "",
--~ 	["Read Chapter 3:  Last Days"] = "",
--~ })

-- bathroom

add_choice_text("Having a Medicine Ball", {
	["Gaze deeply into the mirror"] = "Gain myst",
})

add_choice_text("Don't Hold a Grudge", {
	["Declare a thumb war"] = "Gain myst",
})

-- bedroom

add_choice_text_conditional("One Nightstand", {
	["Check the top drawer"] = "Get coin purse",
	["Check the bottom drawer"] = "Fight nightstand",
	["Look under the nightstand"] = "Spookyraven skill item",
}, function() return string.match(text, "mahogany") end)

add_choice_text_conditional("One Nightstand", {
	["Open the top drawer"] = "Gain meat",
	["Open the bottom drawer"] = "Gain myst",
	["Look behind the nightstand"] = "Get spectacles",
}, function() return string.match(text, "ornately") end)

add_choice_text_conditional("One Nightstand", {
	["Look in the top drawer"] = "Get wallet",
	["Look in the bottom drawer"] = "Gain muscle",
	["Kick it and see what happens"] = "Fight nightstand",
}, function() return string.match(text, "white") end)

add_choice_text_conditional("One Nightstand", {
	["Check the top drawer"] = "Gain mox + unlock key",
	["Check the bottom drawer"] = "Gain ballroom key",
	["Investigate the jewelry"] = "Fight mistress",
}, function() return string.match(text, "wooden") end)

-- ballroom

add_choice_text("Strung-Up Quartet", {
	["&quot;Play 'Provare Compasione Per El Sciocco'&quot;"] = "Set song to +5 ML",
	["&quot;Play 'Sono Un Amanten Non Un Combattente'&quot;"] = "Set song to +5%% non-combats",
	["&quot;Play 'Le Mie Cose Favorite'&quot;"] = "Set song to +5%% items",
	["&quot;Play nothing, please.&quot;"] = "Disable song (does not cost an adventure)",
})

add_choice_text("Curtains", {
	["Investigate the organ"] = "Fight an organist or get moxie spookyraven skill",
	["Watch the dancers"] = "Gain moxie",
	["Pay no attention to the stuff in front of the curtain"] = "Leave (does not cost an adventure)",
})

add_processor("/inv_use.php", function ()
	if (string.match(text, "You pencil your name in on the last line of the dance card, and it evaporates in a puff of ectoplasm.")) then
		addcounter("Dance card", 3)
	end
end)

-- gallery
add_choice_text("Out in the Garden", { -- choice adventure number: 89
	["The first knight"] = "Get SC skill / fight knight (+spooky damage)",
	["The second knight"] = "Get TT skill / <b>fight knight (+ML)</b>",
	["The two maidens"] = "Get Dreams and Lights or lose HP",
})

-- louvre
add_processor("/choice.php", function ()
	if adventure_title == "Louvre It or Leave It " then
		whichchoice = get_ascension_state("adventure.lastchoice.whichchoice")
		option = get_ascension_state("adventure.lastchoice.option")
		if whichchoice == "" then whichchoice = nil else whichchoice = tonumber(whichchoice) end
		if option == "" then option = nil else option = tonumber(option) end
		if choice_adventure_number and whichchoice and option then
			if choice_adventure_number ~= 91 then
				set_ascension_state("louvre.map.adventure." .. tostring(whichchoice) .. ".choice." .. tostring(option), "choice " .. tostring(choice_adventure_number))
--~ 				print("setting", whichchoice, option, "choice", choice_adventure_number)
			end
		end
		set_ascension_state("louvre.lastadventure", tostring(choice_adventure_number))
	else
		lastlouvre = get_ascension_state("louvre.lastadventure")
		if lastlouvre == "" then lastlouvre = nil else lastlouvre = tonumber(lastlouvre) end
--~ 		print("lastlouvre", lastlouvre)
		if lastlouvre then
			whichchoice = get_ascension_state("adventure.lastchoice.whichchoice")
			option = get_ascension_state("adventure.lastchoice.option")
			if whichchoice == "" then whichchoice = nil else whichchoice = tonumber(whichchoice) end
			if option == "" then option = nil else option = tonumber(option) end
--~ 			print("which, opt", whichchoice, option)
			if lastlouvre and whichchoice and option then
				if lastlouvre == whichchoice then
					results = {}
					results["&quot;Hey, Wayne,&quot; he replies."] = "<b>Gain muscle</b>"
					results["the scene fills you with new insight as to the nature of the universe"] = "Gain mysticality"
					results["only playing for dog biscuits"] = "Gain moxie"
					results["Nothing better than a picnic on a bright summer day such as this"] = "Get Manetwich"
					results["a burly bearded guy in a wifebeater and straw hat gives you a funny look"] = "Get bottle of Pinot Renoir"
					results["bed and inspect the awkwardly slanted nightstand"] = "Get bottle of Vangoghbitussin"
					for a, b in pairs(results) do
						if string.match(text, a) then
							set_ascension_state("louvre.map.adventure." .. tostring(whichchoice) .. ".choice." .. tostring(option), "result " .. b)
							print("setting result", whichchoice, option, "result", b)
						end
					end
				end
			end
		end
	end
end)

add_printer("/choice.php", function ()
	if adventure_title == "Louvre It or Leave It " and choice_adventure_number then
		choice_data = {}
		for initialc = 1, 3 do
			initialto = get_ascension_state("louvre.map.adventure." .. tostring(choice_adventure_number) .. ".choice." .. tostring(initialc))
			result_desc = ""
			if initialto ~= "" then
--~ 				print("initial for", initialc, initialto)
				tochoice = string.match(initialto, "^choice ([0-9]+)$")
				toresult = string.match(initialto, "^result (.+)$")
				if tochoice then
					can_hit = {}
					explored = {}
					results = {}
					can_hit[tochoice] = true
					for i = 1, 1000 do -- be absolutely certain to terminate, even if bugged
						for x, _ in pairs(can_hit) do
							if not explored[x] then
--~ 								print("exploring", x)
								explored[x] = true
								for c = 1, 3 do
									to = get_ascension_state("louvre.map.adventure." .. x .. ".choice." .. tostring(c))
									if to ~= "" then
--~ 										print("hitting", to)
										tochoice = string.match(to, "^choice ([0-9]+)$")
										toresult = string.match(to, "^result (.+)$")
										if tochoice then
											can_hit[tochoice] = true
										elseif toresult then
											results[toresult] = true
										end
									end
								end
							end
						end
					end
					found_str = ""
					for a, b in pairs(results) do
						short_desc = string.match(a, "^[A-Za-z]+ (.+)$")
						if not short_desc then
							short_desc = string.match(a, "^<b>[A-Za-z]+ (.+)</b>$")
							if short_desc then short_desc = "<b>" .. short_desc .. "</b>" end
						end
						if found_str ~= "" then found_str = found_str .. ", " end
						found_str = found_str .. short_desc
					end
					if found_str == "" then
						result_desc = "Explore maze"
					else
						result_desc = "Explore maze (found: " .. found_str .. ")"
					end
				elseif toresult then
					result_desc = toresult
				end
			end
			choice_string = string.match(text, [[<input type=hidden name=whichchoice value=]] .. tostring(choice_adventure_number) .. [[><input type=hidden name=option value=]] .. tostring(initialc) .. [[><input class=button type=submit value="([^"]+)">]])
			if choice_string and result_desc ~= "" then
				choice_data[choice_string] = result_desc
			end
		end
		add_choice_text("Louvre It or Leave It ", choice_data)
	end
end)
